
#if defined(SOCKINTERNAL)

#if !defined(_MSC_VER)
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <sys/file.h>
#endif

typedef struct {
  struct sockaddr_in addr; /* address of socket provided by bind() */
  int addrlen;             /* size of the addr struct */
  int sd;                  /* socket file descriptor */
} csocket;

#endif /* SOCKINTERNAL */

#ifdef __cplusplus
extern "C" {
#endif

int   sock_init(void);
void *sock_create(void);
int   sock_bind(void *, int);
int   sock_listen(void *);
void *sock_accept(void *);  /* return new socket */
int   sock_connect(void *, const char *, int);
int   sock_write(void *, const void *, int);
int   sock_read(void *, void *, int);
int   sock_selread(void *, int);
int   sock_selwrite(void *, int);
void  sock_shutdown(void *);
void  sock_destroy(void *);

#ifdef __cplusplus
}
#endif

